body {
    background: #2d2d2d;
    margin: 0;
    color: #4e91bb;

    --data-types-move-width: 2.6rem;
    --data-types-name-width: 17rem;
    --data-types-output-width: 14rem;
    --external-id-width: 7rem;
    --field-description-width: 17rem;
    --field-inherits-width: 17rem;
    --field-type-variables-width: 14rem;

	font-family: 'Do Hyeon', sans-serif;
}

#menu-header 
{
    height: 5.7rem;
    margin: 0;
    padding: 0;
    background: linear-gradient(to bottom, #585858, #3c3c3c);
    box-shadow: black 0px 0px 10px;
    position: relative;
    font-size: 0;
    line-height: 5.7rem;
}

#menu-header-logo
{
    background: url(logo.png);
    width: 13rem;
    background-position-y: -60px;
    background-color: rgba(0,0,0, 0.1);
    margin-left: 0.5rem;
    top: 0.5rem;
    bottom: 0.5rem;
    border-radius: 5px;
    filter: brightness(1.25);
    position: relative;
    height: 4.75rem;
    display: inline-block;
    margin-right: 0.5rem;
}

#menu-header-file-parent
{
    position: relative;
    width: 1rem;
    display: inline-block;
    height: 100%;
    width: 8.7rem;
    top: 0;
    vertical-align: top;
}

#menu-header-load
{
    position: relative;
    height: 1.75rem;
    font-size: 1.75rem;
    line-height: 1.75rem;
    background-color: rgba(0, 0, 0, 0.14);
    box-shadow: inset 0 0 0.1rem #0000008c;
    border-radius: 5px;
    filter: brightness(1.25);
    padding: 0.25rem;
    display: inline-block;
    vertical-align: top;
    top: 1.5rem;
    margin-right: 0.5rem;
}

#menu-header-save
{
    position: relative;
    height: 1.75rem;
    font-size: 1.75rem;
    line-height: 1.75rem;
    background-color: rgba(0, 0, 0, 0.14);
    box-shadow: inset 0 0 0.1rem #0000008c;
    border-radius: 5px;
    filter: brightness(1.25);
    padding: 0.25rem;
    display: inline-block;
    vertical-align: top;
    top: 1.5rem;
}

#menu-header-load:hover,
#menu-header-save:hover
{
	filter: brightness(1.5);
	cursor: pointer;
}

#menu-header-auto-save
{
	height: 1rem;
	vertical-align: top;
	left: 5.2rem;
	cursor: pointer;
	position: absolute;
	top: 4.1rem;
}

#menu-header-auto-save-label
{
	position: absolute;
    height: 1rem;
    font-size: 1rem;
    display: inline-block;
    line-height: 1rem;
    vertical-align: top;
    top: 4.1rem;
    cursor: pointer;
    width: 6rem;
    left: 0;
}

.menu-header-page
{
	background: url(logo.png);
    background-color: rgba(0, 0, 0, 0.14);
    box-shadow: inset 0 0 0.1rem #0000008c;
    margin-left: 0.5rem;
    top: 1.5rem;
    border-radius: 5px;
    filter: brightness(1.25);
    position: relative;
    padding: 0.5rem;
    display: inline-block;
    vertical-align: top;
    font-size: 2rem;
    line-height: 2rem;
}

.menu-header-page:hover
{
	cursor: pointer;
	filter: brightness(1.5);
	background-color: rgba(0, 0, 0, 0.2);
}

.menu-header-page-selected
{
	pointer-events: none;
	filter: brightness(1.5);
	background-color: rgba(0, 0, 0, 0.24);
    box-shadow: inset 0 0 0.2rem orange;
}

#page-content
{
    left: 0;
    right: 0;
    top: 5.7rem;
    bottom: 0;
    position: absolute;
    overflow: auto;
}

#page-content textarea 
{
    resize: none;
    white-space: nowrap;
    overflow: hidden;
    background: none;
    left: 0;
    margin: 0;
    width: 100%;
    height: 1.5rem;
    padding: 0.25rem;
    border: none;
    color: #935ead;
}

table
{
	border-collapse: collapse;
}

td
{
	padding: 0;
}

table, th, td {
  border: 1px solid black;
}

button {
    background: darkgray;
    border: lightgray 2px solid;
    border-radius: 10px;
    margin: 3px;
}

tbody tr:nth-child(4n+1),
tbody tr:nth-child(4n+2) 
{
	background: gray;
}

tbody tr:nth-child(4n+3),
tbody tr:nth-child(4n+4) 
{
	background: lightgray;
}

.sub-entry-row
{
	display: flex;
	align-items: center;
	height: 1.8rem;
}

.fa
{
	padding: 0.3rem;
}

.fa:hover,
.fas:hover
{
	filter: brightness(1.5);
	cursor: pointer;
}

.fas
{
    font-size: 2rem;
    width: 2rem;
    text-align: center;
    height: 2rem;
}

.drag-handle
{
	font-size: 2rem;
    width: 2.6rem;
    height: 2.6rem;
    line-height: 2.6rem;
    text-align: center;
}

#page-header {
	font-size: 1.35rem;
    height: 2.35rem;
    line-height: 2.35rem;
    background: linear-gradient(to bottom, #ffffff21, #ffffff0f);
    border-bottom: solid #00000078 2px;
}

#page-header > div
{
	border-left: solid 2px #00000033;
    padding-left: 1rem;
    height: 100%;
    float: left;
}

#page-header .header-buttons-spacer
{
	border-left: solid 2px #00000033;
	padding-left: 0.1rem;
    height: 100%;
    float: left;
}

#page-header div:last-child
{
	border-right: solid 2px #00000033;
}

.header-buttons-spacer {
    --width: var(--data-types-move-width);
    width: var(--width);
    display: inline-block;
}

.field-name {
    --width: var(--data-types-name-width);
    width: var(--width);
    display: inline-block;
}

.field-output {
    --width: var(--data-types-output-width);
    width: var(--width);
    display: inline-block;
}

.field-external-id {
    --width: var(--external-id-width);
    width: var(--width);
    display: inline-block;
}

.field-inherits {
    --width: var(--field-inherits-width);
    width: var(--width);
    display: inline-block;
}

.field-inherits-variables {
    --width: var(--field-type-variables-width);
    width: var(--width);
    display: inline-block;
}

.field-description {
    --width: var(--field-description-width);
    width: var(--width);
    display: inline-block;
}

.entry-parent .field-name,
.entry-parent .field-output,
.entry-parent .field-external-id,
.entry-parent .field-inherits,
.entry-parent .field-description,
.entry-parent .sub-entry-parent
{
    border: solid 2px #00000033;
    border-top: none;
    border-left: none;
    padding: 0.1rem;
    width: calc(var(--width) + 0.8rem);
    transition: all 0.5s;
    max-height: 100%;
}

.entry-parent 
{
    display: flex;
    width: fit-content;
    border: solid 1px #00000042;
    border-top: none;
}

.entry-parent:nth-child(odd)
{
    background: #313131;
}

.sub-entry-parent {
}

.row-handle {
    display: flex;
    vertical-align: middle;
    align-items: center;
    border: solid 2px #00000033;
    border-top: none;
}

#page-interactions
{
    position: fixed;
    top: 13rem;
    right: 2rem;
    width: 26.9rem;
    overflow: hidden;
    border: solid 2px #00000033;
    border-radius: 1rem;
    background: #383838;
    opacity: 0.7;
    display: none;
    z-index: 10000;
}

#page-interactions > i
{
    height: 7rem;
    font-size: 6rem;
    position: relative;
    float: left;
    width: 49%;
    display: inline-block;
    padding: 0;
    margin: 0;
    text-align: center;
    padding-top: 1rem;
}

#page-interactions > i:first-child
{
    border-right: solid 2px #00000033;
}

.sub-entry-header
{
    border: solid 2px #00000033;
    border-top: none;
    border-left: none;
    padding: 0.3rem;
    padding-left: 0.6rem;
    text-transform: capitalize;
    display: flex;
}

.sub-entry-header:hover
{
    cursor: pointer;
    filter: brightness(1.25);
    background: rgba(255, 255, 255, 0.02);
}

.sub-entry-header:not(.header-open) + div
{
	max-height: 0;
	overflow: hidden;
	border: none;
	padding: 0; 
}

.sub-entry-header.header-open .subrow-header-title
{
	display: none;
}

.sub-entry-header:not(.header-open) .subrow-header-field,
.sub-entry-header:not(.header-open) .subrow-header-spacer
{
	display: none;
}

.columns-header
{
	padding: 0;
}

.columns-rows,
.columns-rows .sub-entry-row
{
	--width: calc(var(--data-types-name-width) + var(--external-id-width) + var(--field-inherits-width) + 2.5rem);
	width: var(--width + 0.8rem);
	padding: 0 !important;
	border-bottom: none;
}

.columns-rows textarea
{
	flex: 1;
	padding: 0.4rem;
	padding-left: 0.1rem;
	padding-right: 0.1rem;
}

.columns-rows > .sub-entry-row > *
{
	border: solid 2px #00000033;
	border-top: none;
	border-left: none;
	height: 100%;
}

.columns-rows > .sub-entry-row > *:last-child
{
	border-right: none;
}

.columns-rows .sub-entry-row:last-child > *
{
	border-bottom: none;
}

.columns-rows .sub-entry-row
{
	margin-bottom: -0.1rem;
}

.columns-rows .fa
{
	padding: 0.35rem;
	height: auto;
}

.columns-rows .fa-trash
{
	border-right: none;
}

.variables-header
{
    pointer-events: none;
    border: solid 2px #00000033;
    border-top: none;
    border-left: none;
    text-transform: capitalize;
    display: flex;
}

.variables-header > *
{
	display: inline-block;
	padding: 0.25rem;
	padding-left: 1rem;
	border-right: solid 2px #00000033;
    position: relative;
    flex: 1;
    padding-left: 1rem;
}

.variables-header > *:last-child
{
	border-right: none;
}

.variables-header > .subrow-header-spacer
{
    padding: 0rem !important;
    flex: 0 0 3.3rem;
}

.variables-row
{
    display: flex;
    align-items: center;
    height: 1.8rem;
}

.variables-row > *
{
	border: solid 2px #00000033;
    border-top: none;
    border-left: none;
    height: 100%;
}

.variables-row > textarea:last-child
{
    padding-left: 0 !important;
}

.custom-combobox
{
    flex: 1;
	display: flex;
    height: 100%;
    margin-bottom: 0.1rem;
    padding-right: 0.2rem;
}

.custom-combobox textarea
{
    height: 100%;
}

.variables-checkbox
{
    flex: 1;
    display: flex;
    align-items: center;
    vertical-align: middle;
    margin-bottom: 0.1rem;
    padding-left: 0.1rem;
    padding-right: 0.1rem;
    border-top: none;
    border-left: none;
    border-right: none;
    border-bottom: solid 2px #00000033;
}

.variables-checkbox:hover
{
	cursor: pointer;
	filter: brightness(1.25);
}

.variables-checkbox:after
{
	content: "open";
    flex: 1;
	position: relative;
	text-align: center;
}

.variables-visible + .variables-checkbox:after
{
	content: "close";
}

.variables-holder
{
    width: 0;
    border: none !important;
    padding: 0;
    margin: 0;
    height: 0;
    position: relative;
    display: none;
    z-index: 1;
}

.variables-visible
{
	display: block;
}

.variables-bin
{
    width: 25rem;
    height: auto;
    position: absolute;
    top: 1.8rem;
    background: rgb(45, 45, 45);
    border: #4e4e4e solid 2px;
}

.variables-header-name
{
	width: 10rem;
}

.variables-header-value
{
	width: 8.9rem;
}

.ui-button
{
    padding: 0;
    margin: 0;
    background: transparent !important;
    border: none !important;
    width: 0.8rem;
}

.ui-button:hover,
{
    filter: brightness(2);
}

.ui-autocomplete
{
	background: #2d2d2d;
    border: #484848 solid 2px !important;
    color: #935ead;
}

.subrow-header-spacer 
{
	border-right: solid 2px #00000033;
    width: 3.3rem;
}

.subrow-header-field,
.subrow-header-title
{
	padding: 0.3rem;
}

.subrow-header-field
{
	border-right: solid 2px #00000033;
	position: relative;
	flex: 1;
	padding-left: 1rem;
}

.subrow-header-field:last-child
{
	border-right: none;
}

.ui-sortable-helper
{
	border-top: solid 2px #00000033;
	background: #2d2d2d;
    opacity: 0.75;
}

input[type='checkbox'] 
{
    position: relative;
    margin: 0;
    height: 1.5rem;
    left: 50%;
    transform: translateX(-50%);
    width: 1rem;
}

.field-description
{
	display: flex;
}

.field-description textarea
{
	white-space: pre-line !important;
	height: auto !important;	
}

#page-list
{
	overflow: auto;
    position: absolute;
    top: 2.5rem;
    bottom: 0;
    left: 0;
    right: 0;
}